// DEFINITIONS //

function load_level1 ();

#define health skill53


// variables //

var wndf_n=0;
var table[289];
var vmode_i;
var fcmode=0;
var levelcomp=0;
var ammunition=0;
var rps;
var mms;
var hudscale;
var ingame=0;
var ngon=0;
var opton=0;
var paused=1;
// info
var snd_vol_i=50;
var music_vol_i=50;
var lastlevel_i=1;
var stencilshd_i=0;
var shothnd;

SOUND* slide = "slide.wav";
SOUND* wbreak = "break.wav";
SOUND* akshoot="ak74_shot.ogg";

// bitmaps //
BMAP* cur="mouse.tga";
BMAP* ng="new_game.jpg";
BMAP* op="options.jpg";
BMAP* ex="exit.jpg";
BMAP* rz="resume.jpg";
BMAP* rs="restart.jpg";
BMAP* mn="mainmenu.jpg";
BMAP* lowq1="low_on.jpg";
BMAP* lowq0="low_off.jpg";
BMAP* highq1="high_on.jpg";
BMAP* highq0="high_off.jpg";
BMAP* sliderbmp="bar.jpg";
BMAP* plop1 = "plop1.tga";
BMAP* plop2 = "plop2.tga";

// panels //
PANEL* splashs =
{
	bmap="splash_normal.jpg";
	pos_x=0;
	pos_y=0;
	layer=3;
	flags=FILTER;
}

PANEL* blackbg =
{
	bmap="black.jpg";
	layer=1;
	flags=SHOW;
}

PANEL* mmenu =
{
	bmap="main.tga";
	button(22,226,ng,ng,ng,newgame,NULL,NULL);
	button(22,339,op,op,op,optishow,NULL,NULL);
	button(22,617,ex,ex,ex,gamexit,NULL,NULL);
	layer=6;
	flags=FILTER;
}

PANEL* pmenu =
{
	bmap="main.tga";
	button(22,199,rz,rz,rz,hidepausem,NULL,NULL);
	button(22,296,rs,rs,rs,resplay,NULL,NULL);
	button(22,396,op,op,op,optishow,NULL,NULL);
	button(22,496,mn,mn,mn,endplay,NULL,NULL);
	button(22,643,ex,ex,ex,gamexit,NULL,NULL);
	layer=6;
	flags=FILTER;
}

PANEL* rightpan =
{
	bmap="right.tga";
	layer=4;
	flags=FILTER;
}

PANEL* optipan =
{
	bmap="opti_panel.jpg";
	button_radio(280,7,lowq1,lowq0,lowq0,disableshadows,NULL,NULL);
	button_radio(440,11,highq1,highq0,highq0,enableshadows,NULL,NULL);
	hslider(32,109,526,sliderbmp,0,100,snd_vol_i);
	hslider(32,226,526,sliderbmp,0,100,music_vol_i);
	layer=5;
	flags=FILTER;
}


// entities //

ENTITY* skycube =
{
  type = "t_day_sky+6.tga"; // backdrop
  flags2 = SKY | CUBE | SHOW;
}

ENTITY* jucator;



// functions //

function pause_game_at_alt_tab()	
{
	while (1)
	{
		if (window_focus == 0){
			if (!wndf_n){
				wndf_n=1;
				reset(camera,SHOW);
				fps_max=4;
				freeze_mode = 1;
			}
		}else{
			if (wndf_n){
				freeze_mode = 0;
				fps_max=100;
				set(camera,SHOW);
				wndf_n=0;
			}
		}
		wait(1);
	}
}

function switchshadows(){
	if (shadow_stencil==0) shadow_stencil=4;
	else shadow_stencil=0;
}

function enableshadows() {shadow_stencil=4; stencilshd_i=1; game_save("info",0,SV_INFO);}
function disableshadows() {shadow_stencil=0; stencilshd_i=0; game_save("info",0,SV_INFO);}



function aparticle1(PARTICLE *p){
	p->vel_x=(0.5-random(1))*3;
	p->vel_y=(0.5-random(1))*3;
	p->vel_z=random(20);
	p.bmap = plop1;
	p.size = 5;
	p.flags |= (MOVE);
	p.gravity = 2;
	p.event = NULL;
}

function aparticle2(PARTICLE *p){
	p->vel_x=(0.5-random(1))*3;
	p->vel_y=(0.5-random(1))*3;
	p->vel_z=random(5);
	p.bmap = plop2;
	p.size = 7;
	p.flags |= (MOVE);
	p.gravity = 2;
	p.event = NULL;
}



function boxmove(){
	if (event_type == EVENT_PUSH)
	{
		if (abs(me.x-jucator.x)<abs(me.y-jucator.y))
		{	if ((me.y-jucator.y)<0)
				me.skill52=0-3*time_step;
			if ((me.y-jucator.y)>0)
				me.skill52=4*time_step;
		}
		else
		{	if ((me.x-jucator.x)<0)
				me.skill51=0-3*time_step;
			if ((me.x-jucator.x)>0)
				me.skill51=3*time_step;
		}
		reset(me,PASSABLE);
	}
	else
	{
		var bosp[3];
		vec_set(bosp,me.x);
		snd_play(wbreak,snd_vol_i,0);
		ptr_remove(me);
		var i=0;
		var nop;
		while(i<20){
			nop = 30*time_step;
			effect(aparticle1,nop,bosp,nullvector);
			effect(aparticle2,nop,bosp,nullvector);
			i++;
			wait(1);
		}
	}
}



function musicstart()
{
	media_loop("Voyage.mp3",NULL,100);
	while(1)
	{
		midi_vol=music_vol_i;
		wait(1);
	}
}


function showmainm()
{
	
	set(mmenu,SHOW);
	while(mmenu.pos_x<0-0.011)
	{
		if (abs(mmenu.pos_x)<90)
			mmenu.pos_x+=fsin(abs(mmenu.pos_x),80*time_step);
		else
			mmenu.pos_x+=80*time_step;
		wait(1);
	}
	mmenu.pos_x=0;
	mouse_mode=4;
}

function hidemainm()
{
	mmenu.pos_x-=1;
	while(mmenu.pos_x>=0-mms)
	{
		if (abs(mmenu.pos_x)<90)
			mmenu.pos_x-=fsin(abs(mmenu.pos_x),80*time_step);
		else
			mmenu.pos_x-=80*time_step;
		wait(1);
	}
	mmenu.pos_x=0-mms;
	reset(mmenu,SHOW);
}


function showpausem()
{
	set(pmenu,SHOW);
	while(pmenu.pos_x<0-0.011)
	{
		if (abs(pmenu.pos_x)<90)
			pmenu.pos_x+=fsin(abs(pmenu.pos_x),80*time_step);
		else
			pmenu.pos_x+=80*time_step;
		wait(1);
	}
	pmenu.pos_x=0;
}

function hidepausem()
{
	pmenu.pos_x-=1;
	while(pmenu.pos_x>=0-mms)
	{
		if (abs(pmenu.pos_x)<90)
			pmenu.pos_x-=fsin(abs(pmenu.pos_x),80*time_step);
		else
			pmenu.pos_x-=80*time_step;
		wait(1);
	}
	pmenu.pos_x=0-mms;
	reset(pmenu,SHOW);
	if (ingame)
		mouse_mode=0;
}


function showng()
{
	ngon=1;
	rightpan.pos_x=screen_size.x;
	set(rightpan,SHOW);
	while(rightpan.pos_x>screen_size.x-rps+0.005)
	{
		if (rightpan.pos_x<screen_size.x-rps+90)
			rightpan.pos_x-=fsin(rightpan.pos_x-(screen_size.x-rps),80*time_step);
		else
			rightpan.pos_x-=80*time_step;
		wait(1);
	}
	rightpan.pos_x=screen_size.x-rps;
}

function hideng()
{
	rightpan.pos_x+=1;
	while(rightpan.pos_x<screen_size.x)
	{
		if (rightpan.pos_x<screen_size.x-rps+90)
			rightpan.pos_x+=fsin(rightpan.pos_x-(screen_size.x-rps),80*time_step);
		else
			rightpan.pos_x+=80*time_step;
		wait(1);
	}
	rightpan.pos_x=screen_size.x;
	reset(rightpan,SHOW);
	ngon=0;
}


function optishow()
{
	if (ngon)
	{
		hideng();
		while(ngon==1)
			wait(1);
	}
	if (opton==0)
	{
		optipan.pos_x=screen_size.x;
		set(optipan,SHOW);
		opton=1;
		showng();
		while(ngon)
		{
			optipan.pos_x=rightpan.pos_x+143*hudscale;
			optipan.pos_y=rightpan.pos_y+164*hudscale;
			wait(1);
		}
		reset(optipan,SHOW);
	}
	else
	{
		hideng();
		while(ngon)
			wait(1);
		opton=0;
		game_save("info",0,SV_INFO);
	}
	
}


function switchng()
{
	if (rightpan.pos_x==screen_size.x)
		showng();
	if (rightpan.pos_x==screen_size.x-rps)
		hideng();
}

function meniu()
{
	mmenu.scale_x=(screen_size.y/bmap_height(mmenu.bmap));
	mmenu.scale_y=(screen_size.y/bmap_height(mmenu.bmap));
	pmenu.scale_x=(screen_size.y/bmap_height(mmenu.bmap));
	pmenu.scale_y=(screen_size.y/bmap_height(mmenu.bmap));
	mms=500*(screen_size.y/bmap_height(mmenu.bmap));
	mmenu.pos_x=0-mms;
	showmainm();
	rightpan.scale_x=(screen_size.y/bmap_height(rightpan.bmap));
	rightpan.scale_y=(screen_size.y/bmap_height(rightpan.bmap));
	rps=780*(screen_size.y/bmap_height(rightpan.bmap));
	rightpan.pos_x=screen_size.x;
	optipan.scale_x=(screen_size.y/bmap_height(mmenu.bmap));
	optipan.scale_y=(screen_size.y/bmap_height(mmenu.bmap));
	hudscale=(screen_size.y/bmap_height(mmenu.bmap));
	if (stencilshd_i==0)
		button_state(optipan,1,1);
	else
		button_state(optipan,2,1);
}

function splashscr()
{
	/*if (video_aspesct==4/3)
		splashs.bmap="splash_normal.jpg";
	else
		splashs.bmap="splash_wide.jpg";*/
	set(splashs,SHOW);
	blackbg.scale_x=(screen_size.x/bmap_width(blackbg.bmap));
	blackbg.scale_y=(screen_size.y/bmap_height(blackbg.bmap));
	splashs.scale_x=(screen_size.x/bmap_width(splashs.bmap));
	splashs.scale_y=(screen_size.y/bmap_height(splashs.bmap));
	
	set(splashs,TRANSLUCENT);
	splashs.alpha=0;
	wait(-1);
	while(splashs.alpha<=99)
	{
		splashs.alpha+=3*time_step;
		wait(1);
	}
	game_load("info",0);
	if (stencilshd_i==0)
		shadow_stencil=0;
	else
		shadow_stencil=4;
	wait(-3);
	while(splashs.alpha>=1)
	{
		splashs.alpha-=3*time_step;
		wait(1);
	}
	wait(-1);
	reset(splashs,TRANSLUCENT);
	reset(splashs,SHOW);
	blackbg.layer=10;
	musicstart();
	meniu();
	set(blackbg,SHOW);
	set(blackbg,TRANSLUCENT);
	blackbg.alpha=100;
	while(blackbg.alpha>=1)
	{
		blackbg.alpha-=3*time_step;
		wait(1);
	}
	reset(blackbg,TRANSLUCENT);
	reset(blackbg,SHOW);
	
	mouse_map=cur;
	mouse_spot.x=12;
	mouse_spot.y=4;
	mouse_mode=4;
}


function gamexit()
{
	hidemainm();
	hidepausem();
	hideng();
	while(mmenu.pos_x>0-mms || pmenu.pos_x>0-mms)
		wait(1);
	sys_exit("");
}


function newgame()
{
	if (lastlevel_i<=1)
	{
		hideng();
		hidemainm();
		load_level1();
	}
}


function togglepmenu()
{
	hidemainm();
	hideng();
	if (pmenu.pos_x==0)
	{
		hidepausem();
		paused=0;
		mouse_mode=0;
	}
	else
	{
		showpausem();
		paused=1;
		mouse_mode=4;
	}
}

function endplay()
{
	hidepausem();
	ingame=0;
	while(pmenu.pos_x>0-mms)
		wait(1);
	showmainm();
}

function resplay()
{
	hidepausem();
	ingame=0;
	wait(-1);
	load_level1();
}


// actions //

action icastshadow()
{
	set(my,SHADOW);
	while(1)
	{
		if(ingame==0)
		{
			ptr_remove(me);
			return;
		}
		wait(1);
	}
}

action switchset()
{
	set(my,SHADOW);
	me.material = mat_metal;
	set(me,PASSABLE);
	while(1)
	{	if (c_trace(vector(me.x,me.y,0),vector(me.x,me.y,30),IGNORE_PASSABLE+IGNORE_MAPS)==0)
			levelcomp=0;
		if(ingame==0)
		{
			ptr_remove(me);
			return;
		}
		wait(1);
	}
}

action boxset()
{
	set(me,SHADOW);
	set(me,ENABLE_PUSH);
	c_setminmax(me);
	me.push = 3;
	me.emask |= ENABLE_SHOOT;
	me.emask |= ENABLE_PUSH;
	me.skill51=0;
	me.skill52=0;
	me.event = boxmove;
	while (1)
	{
		if (me!=NULL)
		{
			if (c_move(me,vector(me.skill51,me.skill52,0),NULL,IGNORE_PASSABLE+GLIDE)>0)
				snd_play(slide,snd_vol_i,0);
			reset(me,PASSABLE);
			me.skill51=0;
			me.skill52=0;
		
			if(ingame==0) 
			{
				ptr_remove(me);
				return;
			}
		}
		else
		 return;
		wait(1);
	}
}

action doorset()
{
	set(me,SHADOW);
	c_setminmax(me);
	reset(me,PASSABLE);
	me.pan=90;
	while (1)
	{
		if (levelcomp==1)
		{	wait(-2);
			while (me.z>(0-28) && levelcomp==1) {me.z-=3*time_step; wait(1);}
			if (levelcomp==1)
			{
				me.z=0-30;
				set(me,PASSABLE);
			}
		}
		else
		{	reset(me,PASSABLE);
			while (me.z<(1)) {me.z+=3*time_step; wait(1);}
			me.z=1;
		}
		if(ingame==0) 
		{
			ptr_remove(me);
			return;
		}
		wait(1);
	}
	
}